<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/clap-3.2.16/src/builder/arg_group.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>arg_group.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container"><img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../clap/index.html"><div class="logo-container">
                    <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../clap/index.html">
                        <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
<span id="526">526</span>
<span id="527">527</span>
<span id="528">528</span>
<span id="529">529</span>
<span id="530">530</span>
<span id="531">531</span>
<span id="532">532</span>
<span id="533">533</span>
<span id="534">534</span>
<span id="535">535</span>
<span id="536">536</span>
<span id="537">537</span>
<span id="538">538</span>
<span id="539">539</span>
<span id="540">540</span>
<span id="541">541</span>
<span id="542">542</span>
<span id="543">543</span>
<span id="544">544</span>
<span id="545">545</span>
<span id="546">546</span>
<span id="547">547</span>
<span id="548">548</span>
<span id="549">549</span>
<span id="550">550</span>
<span id="551">551</span>
<span id="552">552</span>
<span id="553">553</span>
<span id="554">554</span>
<span id="555">555</span>
<span id="556">556</span>
<span id="557">557</span>
<span id="558">558</span>
<span id="559">559</span>
<span id="560">560</span>
<span id="561">561</span>
<span id="562">562</span>
<span id="563">563</span>
<span id="564">564</span>
<span id="565">565</span>
<span id="566">566</span>
<span id="567">567</span>
<span id="568">568</span>
<span id="569">569</span>
<span id="570">570</span>
<span id="571">571</span>
<span id="572">572</span>
<span id="573">573</span>
<span id="574">574</span>
<span id="575">575</span>
<span id="576">576</span>
<span id="577">577</span>
<span id="578">578</span>
<span id="579">579</span>
<span id="580">580</span>
<span id="581">581</span>
<span id="582">582</span>
<span id="583">583</span>
<span id="584">584</span>
<span id="585">585</span>
<span id="586">586</span>
<span id="587">587</span>
<span id="588">588</span>
<span id="589">589</span>
<span id="590">590</span>
<span id="591">591</span>
<span id="592">592</span>
<span id="593">593</span>
<span id="594">594</span>
<span id="595">595</span>
<span id="596">596</span>
<span id="597">597</span>
<span id="598">598</span>
<span id="599">599</span>
<span id="600">600</span>
<span id="601">601</span>
<span id="602">602</span>
<span id="603">603</span>
<span id="604">604</span>
<span id="605">605</span>
<span id="606">606</span>
<span id="607">607</span>
<span id="608">608</span>
<span id="609">609</span>
<span id="610">610</span>
<span id="611">611</span>
<span id="612">612</span>
<span id="613">613</span>
<span id="614">614</span>
<span id="615">615</span>
<span id="616">616</span>
<span id="617">617</span>
<span id="618">618</span>
<span id="619">619</span>
<span id="620">620</span>
<span id="621">621</span>
<span id="622">622</span>
<span id="623">623</span>
<span id="624">624</span>
<span id="625">625</span>
<span id="626">626</span>
<span id="627">627</span>
<span id="628">628</span>
<span id="629">629</span>
<span id="630">630</span>
<span id="631">631</span>
<span id="632">632</span>
<span id="633">633</span>
</pre><pre class="rust"><code><span class="comment">// Internal</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::util</span>::{<span class="ident">Id</span>, <span class="ident">Key</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">yaml_rust::Yaml</span>;

<span class="doccomment">/// Family of related [arguments].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// By placing arguments in a logical group, you can create easier requirement and</span>
<span class="doccomment">/// exclusion rules instead of having to list each argument individually, or when you want a rule</span>
<span class="doccomment">/// to apply &quot;any but not all&quot; arguments.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For instance, you can make an entire `ArgGroup` required. If [`ArgGroup::multiple(true)`] is</span>
<span class="doccomment">/// set, this means that at least one argument from that group must be present. If</span>
<span class="doccomment">/// [`ArgGroup::multiple(false)`] is set (the default), one and *only* one must be present.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// You can also do things such as name an entire `ArgGroup` as a [conflict] or [requirement] for</span>
<span class="doccomment">/// another argument, meaning any of the arguments that belong to that group will cause a failure</span>
<span class="doccomment">/// if present, or must be present respectively.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Perhaps the most common use of `ArgGroup`s is to require one and *only* one argument to be</span>
<span class="doccomment">/// present out of a given set. Imagine that you had multiple arguments, and you want one of them</span>
<span class="doccomment">/// to be required, but making all of them required isn&#39;t feasible because perhaps they conflict</span>
<span class="doccomment">/// with each other. For example, lets say that you were building an application where one could</span>
<span class="doccomment">/// set a given version number by supplying a string with an option argument, i.e.</span>
<span class="doccomment">/// `--set-ver v1.2.3`, you also wanted to support automatically using a previous version number</span>
<span class="doccomment">/// and simply incrementing one of the three numbers. So you create three flags `--major`,</span>
<span class="doccomment">/// `--minor`, and `--patch`. All of these arguments shouldn&#39;t be used at one time but you want to</span>
<span class="doccomment">/// specify that *at least one* of them is used. For this, you can create a group.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Finally, you may use `ArgGroup`s to pull a value from a group of arguments when you don&#39;t care</span>
<span class="doccomment">/// exactly which argument was actually used at runtime.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The following example demonstrates using an `ArgGroup` to ensure that one, and only one, of</span>
<span class="doccomment">/// the arguments from the specified group is present at runtime.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```rust</span>
<span class="doccomment">/// # use clap::{Command, arg, ArgGroup, ErrorKind};</span>
<span class="doccomment">/// let result = Command::new(&quot;cmd&quot;)</span>
<span class="doccomment">///     .arg(arg!(--&quot;set-ver&quot; &lt;ver&gt; &quot;set the version manually&quot;).required(false))</span>
<span class="doccomment">///     .arg(arg!(--major           &quot;auto increase major&quot;))</span>
<span class="doccomment">///     .arg(arg!(--minor           &quot;auto increase minor&quot;))</span>
<span class="doccomment">///     .arg(arg!(--patch           &quot;auto increase patch&quot;))</span>
<span class="doccomment">///     .group(ArgGroup::new(&quot;vers&quot;)</span>
<span class="doccomment">///          .args(&amp;[&quot;set-ver&quot;, &quot;major&quot;, &quot;minor&quot;, &quot;patch&quot;])</span>
<span class="doccomment">///          .required(true))</span>
<span class="doccomment">///     .try_get_matches_from(vec![&quot;cmd&quot;, &quot;--major&quot;, &quot;--patch&quot;]);</span>
<span class="doccomment">/// // Because we used two args in the group it&#39;s an error</span>
<span class="doccomment">/// assert!(result.is_err());</span>
<span class="doccomment">/// let err = result.unwrap_err();</span>
<span class="doccomment">/// assert_eq!(err.kind(), ErrorKind::ArgumentConflict);</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// This next example shows a passing parse of the same scenario</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```rust</span>
<span class="doccomment">/// # use clap::{Command, arg, ArgGroup};</span>
<span class="doccomment">/// let result = Command::new(&quot;cmd&quot;)</span>
<span class="doccomment">///     .arg(arg!(--&quot;set-ver&quot; &lt;ver&gt; &quot;set the version manually&quot;).required(false))</span>
<span class="doccomment">///     .arg(arg!(--major           &quot;auto increase major&quot;))</span>
<span class="doccomment">///     .arg(arg!(--minor           &quot;auto increase minor&quot;))</span>
<span class="doccomment">///     .arg(arg!(--patch           &quot;auto increase patch&quot;))</span>
<span class="doccomment">///     .group(ArgGroup::new(&quot;vers&quot;)</span>
<span class="doccomment">///          .args(&amp;[&quot;set-ver&quot;, &quot;major&quot;, &quot;minor&quot;,&quot;patch&quot;])</span>
<span class="doccomment">///          .required(true))</span>
<span class="doccomment">///     .try_get_matches_from(vec![&quot;cmd&quot;, &quot;--major&quot;]);</span>
<span class="doccomment">/// assert!(result.is_ok());</span>
<span class="doccomment">/// let matches = result.unwrap();</span>
<span class="doccomment">/// // We may not know which of the args was used, so we can test for the group...</span>
<span class="doccomment">/// assert!(matches.contains_id(&quot;vers&quot;));</span>
<span class="doccomment">/// // we could also alternatively check each arg individually (not shown here)</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// [`ArgGroup::multiple(true)`]: ArgGroup::multiple()</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`ArgGroup::multiple(false)`]: ArgGroup::multiple()</span>
<span class="doccomment">/// [arguments]: crate::Arg</span>
<span class="doccomment">/// [conflict]: crate::Arg::conflicts_with()</span>
<span class="doccomment">/// [requirement]: crate::Arg::requires()</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Default</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ArgGroup</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">id</span>: <span class="ident">Id</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">str</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">args</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Id</span><span class="op">&gt;</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">required</span>: <span class="ident">bool</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">requires</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Id</span><span class="op">&gt;</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">conflicts</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Id</span><span class="op">&gt;</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">multiple</span>: <span class="ident">bool</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> <span class="ident">ArgGroup</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">with_id</span>(<span class="ident">id</span>: <span class="ident">Id</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">ArgGroup</span> {
            <span class="ident">id</span>,
            ..<span class="ident">ArgGroup::default</span>()
        }
    }

    <span class="doccomment">/// Create a `ArgGroup` using a unique name.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The name will be used to get values from the group or refer to the group inside of conflict</span>
    <span class="doccomment">/// and requirement rules.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, ArgGroup};</span>
    <span class="doccomment">/// ArgGroup::new(&quot;config&quot;)</span>
    <span class="doccomment">/// # ;</span>
    <span class="doccomment">/// ```</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span><span class="op">&lt;</span><span class="ident">S</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">str</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">n</span>: <span class="ident">S</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">ArgGroup::default</span>().<span class="ident">id</span>(<span class="ident">n</span>)
    }

    <span class="doccomment">/// Sets the group name.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, ArgGroup};</span>
    <span class="doccomment">/// ArgGroup::default().name(&quot;config&quot;)</span>
    <span class="doccomment">/// # ;</span>
    <span class="doccomment">/// ```</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">id</span><span class="op">&lt;</span><span class="ident">S</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">str</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">n</span>: <span class="ident">S</span>) -&gt; <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">name</span> <span class="op">=</span> <span class="ident">n</span>.<span class="ident">into</span>();
        <span class="self">self</span>.<span class="ident">id</span> <span class="op">=</span> <span class="ident">Id::from</span>(<span class="self">self</span>.<span class="ident">name</span>);
        <span class="self">self</span>
    }

    <span class="doccomment">/// Deprecated, replaced with [`ArgGroup::id`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.1.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `ArgGroup::id`&quot;</span>)
    )]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span><span class="op">&lt;</span><span class="ident">S</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">str</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">n</span>: <span class="ident">S</span>) -&gt; <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">id</span>(<span class="ident">n</span>)
    }

    <span class="doccomment">/// Adds an [argument] to this group by name</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup};</span>
    <span class="doccomment">/// let m = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .arg(&quot;flag&quot;)</span>
    <span class="doccomment">///         .arg(&quot;color&quot;))</span>
    <span class="doccomment">///     .get_matches_from(vec![&quot;myprog&quot;, &quot;-f&quot;]);</span>
    <span class="doccomment">/// // maybe we don&#39;t know which of the two flags was used...</span>
    <span class="doccomment">/// assert!(m.contains_id(&quot;req_flags&quot;));</span>
    <span class="doccomment">/// // but we can also check individually if needed</span>
    <span class="doccomment">/// assert!(m.contains_id(&quot;flag&quot;));</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// [argument]: crate::Arg</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">arg</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Key</span><span class="op">&gt;</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">arg_id</span>: <span class="ident">T</span>) -&gt; <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">args</span>.<span class="ident">push</span>(<span class="ident">arg_id</span>.<span class="ident">into</span>());
        <span class="self">self</span>
    }

    <span class="doccomment">/// Adds multiple [arguments] to this group by name</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup};</span>
    <span class="doccomment">/// let m = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;]))</span>
    <span class="doccomment">///     .get_matches_from(vec![&quot;myprog&quot;, &quot;-f&quot;]);</span>
    <span class="doccomment">/// // maybe we don&#39;t know which of the two flags was used...</span>
    <span class="doccomment">/// assert!(m.contains_id(&quot;req_flags&quot;));</span>
    <span class="doccomment">/// // but we can also check individually if needed</span>
    <span class="doccomment">/// assert!(m.contains_id(&quot;flag&quot;));</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// [arguments]: crate::Arg</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">args</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Key</span><span class="op">&gt;</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">ns</span>: <span class="kw-2">&amp;</span>[<span class="ident">T</span>]) -&gt; <span class="self">Self</span> {
        <span class="kw">for</span> <span class="ident">n</span> <span class="kw">in</span> <span class="ident">ns</span> {
            <span class="self">self</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">arg</span>(<span class="ident">n</span>);
        }
        <span class="self">self</span>
    }

    <span class="doccomment">/// Allows more than one of the [`Arg`]s in this group to be used. (Default: `false`)</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Notice in this example we use *both* the `-f` and `-c` flags which are both part of the</span>
    <span class="doccomment">/// group</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup};</span>
    <span class="doccomment">/// let m = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;])</span>
    <span class="doccomment">///         .multiple(true))</span>
    <span class="doccomment">///     .get_matches_from(vec![&quot;myprog&quot;, &quot;-f&quot;, &quot;-c&quot;]);</span>
    <span class="doccomment">/// // maybe we don&#39;t know which of the two flags was used...</span>
    <span class="doccomment">/// assert!(m.contains_id(&quot;req_flags&quot;));</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// In this next example, we show the default behavior (i.e. `multiple(false)) which will throw</span>
    <span class="doccomment">/// an error if more than one of the args in the group was used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup, ErrorKind};</span>
    <span class="doccomment">/// let result = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;]))</span>
    <span class="doccomment">///     .try_get_matches_from(vec![&quot;myprog&quot;, &quot;-f&quot;, &quot;-c&quot;]);</span>
    <span class="doccomment">/// // Because we used both args in the group it&#39;s an error</span>
    <span class="doccomment">/// assert!(result.is_err());</span>
    <span class="doccomment">/// let err = result.unwrap_err();</span>
    <span class="doccomment">/// assert_eq!(err.kind(), ErrorKind::ArgumentConflict);</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [`Arg`]: crate::Arg</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">multiple</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">multiple</span> <span class="op">=</span> <span class="ident">yes</span>;
        <span class="self">self</span>
    }

    <span class="doccomment">/// Require an argument from the group to be present when parsing.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is unless conflicting with another argument.  A required group will be displayed in</span>
    <span class="doccomment">/// the usage string of the application in the format `&lt;arg|arg2|arg3&gt;`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **NOTE:** This setting only applies to the current [`Command`] / [`Subcommand`]s, and not</span>
    <span class="doccomment">/// globally.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **NOTE:** By default, [`ArgGroup::multiple`] is set to `false` which when combined with</span>
    <span class="doccomment">/// `ArgGroup::required(true)` states, &quot;One and *only one* arg must be used from this group.</span>
    <span class="doccomment">/// Use of more than one arg is an error.&quot; Vice setting `ArgGroup::multiple(true)` which</span>
    <span class="doccomment">/// states, &#39;*At least* one arg from this group must be used. Using multiple is OK.&quot;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup, ErrorKind};</span>
    <span class="doccomment">/// let result = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;])</span>
    <span class="doccomment">///         .required(true))</span>
    <span class="doccomment">///     .try_get_matches_from(vec![&quot;myprog&quot;]);</span>
    <span class="doccomment">/// // Because we didn&#39;t use any of the args in the group, it&#39;s an error</span>
    <span class="doccomment">/// assert!(result.is_err());</span>
    <span class="doccomment">/// let err = result.unwrap_err();</span>
    <span class="doccomment">/// assert_eq!(err.kind(), ErrorKind::MissingRequiredArgument);</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [`Subcommand`]: crate::Subcommand</span>
    <span class="doccomment">/// [`ArgGroup::multiple`]: ArgGroup::multiple()</span>
    <span class="doccomment">/// [`Command`]: crate::Command</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">required</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">yes</span>: <span class="ident">bool</span>) -&gt; <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">required</span> <span class="op">=</span> <span class="ident">yes</span>;
        <span class="self">self</span>
    }

    <span class="doccomment">/// Specify an argument or group that must be present when this group is.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is not to be confused with a [required group]. Requirement rules function just like</span>
    <span class="doccomment">/// [argument requirement rules], you can name other arguments or groups that must be present</span>
    <span class="doccomment">/// when any one of the arguments from this group is used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **NOTE:** The name provided may be an argument or group name</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup, ErrorKind};</span>
    <span class="doccomment">/// let result = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;debug&quot;)</span>
    <span class="doccomment">///         .short(&#39;d&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;])</span>
    <span class="doccomment">///         .requires(&quot;debug&quot;))</span>
    <span class="doccomment">///     .try_get_matches_from(vec![&quot;myprog&quot;, &quot;-c&quot;]);</span>
    <span class="doccomment">/// // because we used an arg from the group, and the group requires &quot;-d&quot; to be used, it&#39;s an</span>
    <span class="doccomment">/// // error</span>
    <span class="doccomment">/// assert!(result.is_err());</span>
    <span class="doccomment">/// let err = result.unwrap_err();</span>
    <span class="doccomment">/// assert_eq!(err.kind(), ErrorKind::MissingRequiredArgument);</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// [required group]: ArgGroup::required()</span>
    <span class="doccomment">/// [argument requirement rules]: crate::Arg::requires()</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">requires</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Key</span><span class="op">&gt;</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">id</span>: <span class="ident">T</span>) -&gt; <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">requires</span>.<span class="ident">push</span>(<span class="ident">id</span>.<span class="ident">into</span>());
        <span class="self">self</span>
    }

    <span class="doccomment">/// Specify arguments or groups that must be present when this group is.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is not to be confused with a [required group]. Requirement rules function just like</span>
    <span class="doccomment">/// [argument requirement rules], you can name other arguments or groups that must be present</span>
    <span class="doccomment">/// when one of the arguments from this group is used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **NOTE:** The names provided may be an argument or group name</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup, ErrorKind};</span>
    <span class="doccomment">/// let result = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;debug&quot;)</span>
    <span class="doccomment">///         .short(&#39;d&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;verb&quot;)</span>
    <span class="doccomment">///         .short(&#39;v&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;])</span>
    <span class="doccomment">///         .requires_all(&amp;[&quot;debug&quot;, &quot;verb&quot;]))</span>
    <span class="doccomment">///     .try_get_matches_from(vec![&quot;myprog&quot;, &quot;-c&quot;, &quot;-d&quot;]);</span>
    <span class="doccomment">/// // because we used an arg from the group, and the group requires &quot;-d&quot; and &quot;-v&quot; to be used,</span>
    <span class="doccomment">/// // yet we only used &quot;-d&quot; it&#39;s an error</span>
    <span class="doccomment">/// assert!(result.is_err());</span>
    <span class="doccomment">/// let err = result.unwrap_err();</span>
    <span class="doccomment">/// assert_eq!(err.kind(), ErrorKind::MissingRequiredArgument);</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// [required group]: ArgGroup::required()</span>
    <span class="doccomment">/// [argument requirement rules]: crate::Arg::requires_all()</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">requires_all</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">ns</span>: <span class="kw-2">&amp;</span>[<span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">str</span>]) -&gt; <span class="self">Self</span> {
        <span class="kw">for</span> <span class="ident">n</span> <span class="kw">in</span> <span class="ident">ns</span> {
            <span class="self">self</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">requires</span>(<span class="ident">n</span>);
        }
        <span class="self">self</span>
    }

    <span class="doccomment">/// Specify an argument or group that must **not** be present when this group is.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Exclusion (aka conflict) rules function just like [argument exclusion rules], you can name</span>
    <span class="doccomment">/// other arguments or groups that must *not* be present when one of the arguments from this</span>
    <span class="doccomment">/// group are used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **NOTE:** The name provided may be an argument, or group name</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup, ErrorKind};</span>
    <span class="doccomment">/// let result = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;debug&quot;)</span>
    <span class="doccomment">///         .short(&#39;d&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;])</span>
    <span class="doccomment">///         .conflicts_with(&quot;debug&quot;))</span>
    <span class="doccomment">///     .try_get_matches_from(vec![&quot;myprog&quot;, &quot;-c&quot;, &quot;-d&quot;]);</span>
    <span class="doccomment">/// // because we used an arg from the group, and the group conflicts with &quot;-d&quot;, it&#39;s an error</span>
    <span class="doccomment">/// assert!(result.is_err());</span>
    <span class="doccomment">/// let err = result.unwrap_err();</span>
    <span class="doccomment">/// assert_eq!(err.kind(), ErrorKind::ArgumentConflict);</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// [argument exclusion rules]: crate::Arg::conflicts_with()</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">conflicts_with</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Key</span><span class="op">&gt;</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">id</span>: <span class="ident">T</span>) -&gt; <span class="self">Self</span> {
        <span class="self">self</span>.<span class="ident">conflicts</span>.<span class="ident">push</span>(<span class="ident">id</span>.<span class="ident">into</span>());
        <span class="self">self</span>
    }

    <span class="doccomment">/// Specify arguments or groups that must **not** be present when this group is.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Exclusion rules function just like [argument exclusion rules], you can name other arguments</span>
    <span class="doccomment">/// or groups that must *not* be present when one of the arguments from this group are used.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// **NOTE:** The names provided may be an argument, or group name</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Examples</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```rust</span>
    <span class="doccomment">/// # use clap::{Command, Arg, ArgGroup, ErrorKind};</span>
    <span class="doccomment">/// let result = Command::new(&quot;myprog&quot;)</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;flag&quot;)</span>
    <span class="doccomment">///         .short(&#39;f&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;color&quot;)</span>
    <span class="doccomment">///         .short(&#39;c&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;debug&quot;)</span>
    <span class="doccomment">///         .short(&#39;d&#39;))</span>
    <span class="doccomment">///     .arg(Arg::new(&quot;verb&quot;)</span>
    <span class="doccomment">///         .short(&#39;v&#39;))</span>
    <span class="doccomment">///     .group(ArgGroup::new(&quot;req_flags&quot;)</span>
    <span class="doccomment">///         .args(&amp;[&quot;flag&quot;, &quot;color&quot;])</span>
    <span class="doccomment">///         .conflicts_with_all(&amp;[&quot;debug&quot;, &quot;verb&quot;]))</span>
    <span class="doccomment">///     .try_get_matches_from(vec![&quot;myprog&quot;, &quot;-c&quot;, &quot;-v&quot;]);</span>
    <span class="doccomment">/// // because we used an arg from the group, and the group conflicts with either &quot;-v&quot; or &quot;-d&quot;</span>
    <span class="doccomment">/// // it&#39;s an error</span>
    <span class="doccomment">/// assert!(result.is_err());</span>
    <span class="doccomment">/// let err = result.unwrap_err();</span>
    <span class="doccomment">/// assert_eq!(err.kind(), ErrorKind::ArgumentConflict);</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [argument exclusion rules]: crate::Arg::conflicts_with_all()</span>
    <span class="attribute">#[<span class="ident">must_use</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">conflicts_with_all</span>(<span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">ns</span>: <span class="kw-2">&amp;</span>[<span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">str</span>]) -&gt; <span class="self">Self</span> {
        <span class="kw">for</span> <span class="ident">n</span> <span class="kw">in</span> <span class="ident">ns</span> {
            <span class="self">self</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">conflicts_with</span>(<span class="ident">n</span>);
        }
        <span class="self">self</span>
    }

    <span class="doccomment">/// Deprecated, replaced with [`ArgGroup::new`]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Replaced with `ArgGroup::new`&quot;</span>)
    )]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">with_name</span><span class="op">&lt;</span><span class="ident">S</span>: <span class="ident">Into</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">str</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="ident">n</span>: <span class="ident">S</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::new</span>(<span class="ident">n</span>)
    }

    <span class="doccomment">/// Deprecated in [Issue #3087](https://github.com/clap-rs/clap/issues/3087), maybe [`clap::Parser`][crate::Parser] would fit your use case?</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(
        <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;deprecated&quot;</span>,
        <span class="ident">deprecated</span>(
            <span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;3.0.0&quot;</span>,
            <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;Maybe clap::Parser would fit your use case? (Issue #3087)&quot;</span>
        )
    )]</span>
    <span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_yaml</span>(<span class="ident">yaml</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">Yaml</span>) -&gt; <span class="self">Self</span> {
        <span class="ident"><span class="self">Self</span>::from</span>(<span class="ident">yaml</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;_</span> <span class="ident">ArgGroup</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">ArgGroup</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">g</span>: <span class="kw-2">&amp;</span><span class="ident">ArgGroup</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">ArgGroup</span> {
            <span class="ident">id</span>: <span class="ident">g</span>.<span class="ident">id</span>.<span class="ident">clone</span>(),
            <span class="ident">name</span>: <span class="ident">g</span>.<span class="ident">name</span>,
            <span class="ident">required</span>: <span class="ident">g</span>.<span class="ident">required</span>,
            <span class="ident">args</span>: <span class="ident">g</span>.<span class="ident">args</span>.<span class="ident">clone</span>(),
            <span class="ident">requires</span>: <span class="ident">g</span>.<span class="ident">requires</span>.<span class="ident">clone</span>(),
            <span class="ident">conflicts</span>: <span class="ident">g</span>.<span class="ident">conflicts</span>.<span class="ident">clone</span>(),
            <span class="ident">multiple</span>: <span class="ident">g</span>.<span class="ident">multiple</span>,
        }
    }
}

<span class="doccomment">/// Deprecated in [Issue #3087](https://github.com/clap-rs/clap/issues/3087), maybe [`clap::Parser`][crate::Parser] would fit your use case?</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">Yaml</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">ArgGroup</span><span class="op">&lt;</span><span class="lifetime">&#39;help</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Deprecated in [Issue #3087](https://github.com/clap-rs/clap/issues/3087), maybe [`clap::Parser`][crate::Parser] would fit your use case?</span>
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">y</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;help</span> <span class="ident">Yaml</span>) -&gt; <span class="self">Self</span> {
        <span class="kw">let</span> <span class="ident">b</span> <span class="op">=</span> <span class="ident">y</span>.<span class="ident">as_hash</span>().<span class="ident">expect</span>(<span class="string">&quot;ArgGroup::from::&lt;Yaml&gt; expects a table&quot;</span>);
        <span class="comment">// We WANT this to panic on error...so expect() is good.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">a</span> <span class="op">=</span> <span class="ident">ArgGroup::default</span>();
        <span class="kw">let</span> <span class="ident">group_settings</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">b</span>.<span class="ident">len</span>() <span class="op">==</span> <span class="number">1</span> {
            <span class="kw">let</span> <span class="ident">name_yaml</span> <span class="op">=</span> <span class="ident">b</span>.<span class="ident">keys</span>().<span class="ident">next</span>().<span class="ident">expect</span>(<span class="string">&quot;failed to get name&quot;</span>);
            <span class="kw">let</span> <span class="ident">name_str</span> <span class="op">=</span> <span class="ident">name_yaml</span>
                .<span class="ident">as_str</span>()
                .<span class="ident">expect</span>(<span class="string">&quot;failed to convert arg YAML name to str&quot;</span>);
            <span class="ident">a</span>.<span class="ident">name</span> <span class="op">=</span> <span class="ident">name_str</span>;
            <span class="ident">a</span>.<span class="ident">id</span> <span class="op">=</span> <span class="ident">Id::from</span>(<span class="kw-2">&amp;</span><span class="ident">a</span>.<span class="ident">name</span>);
            <span class="ident">b</span>.<span class="ident">get</span>(<span class="ident">name_yaml</span>)
                .<span class="ident">expect</span>(<span class="string">&quot;failed to get name_str&quot;</span>)
                .<span class="ident">as_hash</span>()
                .<span class="ident">expect</span>(<span class="string">&quot;failed to convert to a hash&quot;</span>)
        } <span class="kw">else</span> {
            <span class="ident">b</span>
        };

        <span class="kw">for</span> (<span class="ident">k</span>, <span class="ident">v</span>) <span class="kw">in</span> <span class="ident">group_settings</span> {
            <span class="ident">a</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">k</span>.<span class="ident">as_str</span>().<span class="ident">unwrap</span>() {
                <span class="string">&quot;required&quot;</span> =&gt; <span class="ident">a</span>.<span class="ident">required</span>(<span class="ident">v</span>.<span class="ident">as_bool</span>().<span class="ident">unwrap</span>()),
                <span class="string">&quot;multiple&quot;</span> =&gt; <span class="ident">a</span>.<span class="ident">multiple</span>(<span class="ident">v</span>.<span class="ident">as_bool</span>().<span class="ident">unwrap</span>()),
                <span class="string">&quot;args&quot;</span> =&gt; <span class="macro">yaml_vec_or_str!</span>(<span class="ident">a</span>, <span class="ident">v</span>, <span class="ident">arg</span>),
                <span class="string">&quot;arg&quot;</span> =&gt; {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">ys</span>) <span class="op">=</span> <span class="ident">v</span>.<span class="ident">as_str</span>() {
                        <span class="ident">a</span> <span class="op">=</span> <span class="ident">a</span>.<span class="ident">arg</span>(<span class="ident">ys</span>);
                    }
                    <span class="ident">a</span>
                }
                <span class="string">&quot;requires&quot;</span> =&gt; <span class="macro">yaml_vec_or_str!</span>(<span class="ident">a</span>, <span class="ident">v</span>, <span class="ident">requires</span>),
                <span class="string">&quot;conflicts_with&quot;</span> =&gt; <span class="macro">yaml_vec_or_str!</span>(<span class="ident">a</span>, <span class="ident">v</span>, <span class="ident">conflicts_with</span>),
                <span class="string">&quot;name&quot;</span> =&gt; {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">ys</span>) <span class="op">=</span> <span class="ident">v</span>.<span class="ident">as_str</span>() {
                        <span class="ident">a</span> <span class="op">=</span> <span class="ident">a</span>.<span class="ident">id</span>(<span class="ident">ys</span>);
                    }
                    <span class="ident">a</span>
                }
                <span class="ident">s</span> =&gt; <span class="macro">panic!</span>(
                    <span class="string">&quot;Unknown ArgGroup setting &#39;{}&#39; in YAML file for \
                     ArgGroup &#39;{}&#39;&quot;</span>,
                    <span class="ident">s</span>, <span class="ident">a</span>.<span class="ident">name</span>
                ),
            }
        }

        <span class="ident">a</span>
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">test</span> {
    <span class="kw">use</span> <span class="ident"><span class="kw">super</span>::ArgGroup</span>;
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
    <span class="kw">use</span> <span class="ident">yaml_rust::YamlLoader</span>;

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">groups</span>() {
        <span class="kw">let</span> <span class="ident">g</span> <span class="op">=</span> <span class="ident">ArgGroup::new</span>(<span class="string">&quot;test&quot;</span>)
            .<span class="ident">arg</span>(<span class="string">&quot;a1&quot;</span>)
            .<span class="ident">arg</span>(<span class="string">&quot;a4&quot;</span>)
            .<span class="ident">args</span>(<span class="kw-2">&amp;</span>[<span class="string">&quot;a2&quot;</span>, <span class="string">&quot;a3&quot;</span>])
            .<span class="ident">required</span>(<span class="bool-val">true</span>)
            .<span class="ident">conflicts_with</span>(<span class="string">&quot;c1&quot;</span>)
            .<span class="ident">conflicts_with_all</span>(<span class="kw-2">&amp;</span>[<span class="string">&quot;c2&quot;</span>, <span class="string">&quot;c3&quot;</span>])
            .<span class="ident">conflicts_with</span>(<span class="string">&quot;c4&quot;</span>)
            .<span class="ident">requires</span>(<span class="string">&quot;r1&quot;</span>)
            .<span class="ident">requires_all</span>(<span class="kw-2">&amp;</span>[<span class="string">&quot;r2&quot;</span>, <span class="string">&quot;r3&quot;</span>])
            .<span class="ident">requires</span>(<span class="string">&quot;r4&quot;</span>);

        <span class="kw">let</span> <span class="ident">args</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;a1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a4&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a3&quot;</span>.<span class="ident">into</span>()];
        <span class="kw">let</span> <span class="ident">reqs</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;r1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r3&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r4&quot;</span>.<span class="ident">into</span>()];
        <span class="kw">let</span> <span class="ident">confs</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;c1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c3&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c4&quot;</span>.<span class="ident">into</span>()];

        <span class="macro">assert_eq!</span>(<span class="ident">g</span>.<span class="ident">args</span>, <span class="ident">args</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">g</span>.<span class="ident">requires</span>, <span class="ident">reqs</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">g</span>.<span class="ident">conflicts</span>, <span class="ident">confs</span>);
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_from</span>() {
        <span class="kw">let</span> <span class="ident">g</span> <span class="op">=</span> <span class="ident">ArgGroup::new</span>(<span class="string">&quot;test&quot;</span>)
            .<span class="ident">arg</span>(<span class="string">&quot;a1&quot;</span>)
            .<span class="ident">arg</span>(<span class="string">&quot;a4&quot;</span>)
            .<span class="ident">args</span>(<span class="kw-2">&amp;</span>[<span class="string">&quot;a2&quot;</span>, <span class="string">&quot;a3&quot;</span>])
            .<span class="ident">required</span>(<span class="bool-val">true</span>)
            .<span class="ident">conflicts_with</span>(<span class="string">&quot;c1&quot;</span>)
            .<span class="ident">conflicts_with_all</span>(<span class="kw-2">&amp;</span>[<span class="string">&quot;c2&quot;</span>, <span class="string">&quot;c3&quot;</span>])
            .<span class="ident">conflicts_with</span>(<span class="string">&quot;c4&quot;</span>)
            .<span class="ident">requires</span>(<span class="string">&quot;r1&quot;</span>)
            .<span class="ident">requires_all</span>(<span class="kw-2">&amp;</span>[<span class="string">&quot;r2&quot;</span>, <span class="string">&quot;r3&quot;</span>])
            .<span class="ident">requires</span>(<span class="string">&quot;r4&quot;</span>);

        <span class="kw">let</span> <span class="ident">args</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;a1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a4&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a3&quot;</span>.<span class="ident">into</span>()];
        <span class="kw">let</span> <span class="ident">reqs</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;r1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r3&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r4&quot;</span>.<span class="ident">into</span>()];
        <span class="kw">let</span> <span class="ident">confs</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;c1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c3&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c4&quot;</span>.<span class="ident">into</span>()];

        <span class="kw">let</span> <span class="ident">g2</span> <span class="op">=</span> <span class="ident">ArgGroup::from</span>(<span class="kw-2">&amp;</span><span class="ident">g</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">g2</span>.<span class="ident">args</span>, <span class="ident">args</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">g2</span>.<span class="ident">requires</span>, <span class="ident">reqs</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">g2</span>.<span class="ident">conflicts</span>, <span class="ident">confs</span>);
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;yaml&quot;</span>)]</span>
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_yaml</span>() {
        <span class="kw">let</span> <span class="ident">g_yaml</span> <span class="op">=</span> <span class="string">&quot;name: test
args:
- a1
- a4
- a2
- a3
conflicts_with:
- c1
- c2
- c3
- c4
requires:
- r1
- r2
- r3
- r4&quot;</span>;
        <span class="kw">let</span> <span class="ident">yaml</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">YamlLoader::load_from_str</span>(<span class="ident">g_yaml</span>).<span class="ident">expect</span>(<span class="string">&quot;failed to load YAML file&quot;</span>)[<span class="number">0</span>];
        <span class="kw">let</span> <span class="ident">g</span> <span class="op">=</span> <span class="ident">ArgGroup::from</span>(<span class="ident">yaml</span>);
        <span class="kw">let</span> <span class="ident">args</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;a1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a4&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;a3&quot;</span>.<span class="ident">into</span>()];
        <span class="kw">let</span> <span class="ident">reqs</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;r1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r3&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;r4&quot;</span>.<span class="ident">into</span>()];
        <span class="kw">let</span> <span class="ident">confs</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">&quot;c1&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c2&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c3&quot;</span>.<span class="ident">into</span>(), <span class="string">&quot;c4&quot;</span>.<span class="ident">into</span>()];
        <span class="macro">assert_eq!</span>(<span class="ident">g</span>.<span class="ident">args</span>, <span class="ident">args</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">g</span>.<span class="ident">requires</span>, <span class="ident">reqs</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">g</span>.<span class="ident">conflicts</span>, <span class="ident">confs</span>);
    }

    <span class="comment">// This test will *fail to compile* if ArgGroup is not Send + Sync</span>
    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">arg_group_send_sync</span>() {
        <span class="kw">fn</span> <span class="ident">foo</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span><span class="op">&gt;</span>(<span class="kw">_</span>: <span class="ident">T</span>) {}
        <span class="ident">foo</span>(<span class="ident">ArgGroup::new</span>(<span class="string">&quot;test&quot;</span>))
    }
}

<span class="kw">impl</span> <span class="ident">Clone</span> <span class="kw">for</span> <span class="ident">ArgGroup</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">ArgGroup</span> {
            <span class="ident">id</span>: <span class="self">self</span>.<span class="ident">id</span>.<span class="ident">clone</span>(),
            <span class="ident">name</span>: <span class="self">self</span>.<span class="ident">name</span>,
            <span class="ident">required</span>: <span class="self">self</span>.<span class="ident">required</span>,
            <span class="ident">args</span>: <span class="self">self</span>.<span class="ident">args</span>.<span class="ident">clone</span>(),
            <span class="ident">requires</span>: <span class="self">self</span>.<span class="ident">requires</span>.<span class="ident">clone</span>(),
            <span class="ident">conflicts</span>: <span class="self">self</span>.<span class="ident">conflicts</span>.<span class="ident">clone</span>(),
            <span class="ident">multiple</span>: <span class="self">self</span>.<span class="ident">multiple</span>,
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="clap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>